#!/usr/bin/php
<?php
// This sscript will save phone survey data into database

require_once("/var/www/html/fop2/admin/config.php");
require_once("/var/www/html/fop2/admin/functions.php");
require_once("/var/www/html/fop2/admin/system.php");
require_once("/var/www/html/fop2/admin/dblib.php");
require_once("/var/www/html/fop2/admin/asmanager.php");
require_once("/var/www/html/fop2/admin/dbconn.php");

if(php_sapi_name() != 'cli') { die('no way'); }

$script_id = intval($argv[1]);
$data      = $argv[2];
$metadata  = $argv[3];

$decoded = base64_decode($data);
$campos  = preg_split("/\|/",$decoded);

$decoded_metadata = base64_decode($metadata);
$campos_metadata  = preg_split("/\|/",$decoded_metadata);

// add metadata fields (not entered by user) that comes from channel varialbes and
// date and unique session_id to make the format compatible with web based forms
$valid_fields["session_id"] = "varchar(50) primary key not null";
$valid_fields["datetime"] = "timestamp DEFAULT CURRENT_TIMESTAMP";
$valid_fields["uniqueid"] = "varchar(100) not null DEFAULT ''";
$valid_fields["queuenum"] = "varchar(20) not null DEFAULT ''";
$valid_fields["connectedline"] = "varchar(150) not null DEFAULT ''";
$valid_fields["bridgepeer"] = "varchar(150) not null DEFAULT ''";
$valid_fields["callerid"] = "varchar(150) not null DEFAULT ''";

$valid_data['session_id']=substr(md5(rand()), 0, 4)."-".substr(md5(rand()), 0, 7)."=".substr(md5(rand()), 0, 7);

$tablename = "scriptersaveddata_$script_id";

if(!$db->table_exists($tablename)) {
    $createpart = array();
    foreach($valid_fields as $name=>$type) {
       $createpart[] = "`$name` $type";
    }
    $fields = implode(",",$createpart);
    $query = "CREATE table `$tablename` ($fields)";
    $db->consulta($query);
} 

$cuantos = count($campos_metadata);
for($a=1;$a<=$cuantos;$a++) {
    $partes = preg_split("/=/",$campos_metadata[$a-1],2);
    $ff = strtolower($partes[0]);
    if(!isset($valid_fields[$ff])) { $valid_fields[$ff]="varchar(255)"; }
    if(!isset($valid_data[$ff]))   { $valid_data[$ff]=$partes[1]; }
}

$cuantos = count($campos);
for($a=1;$a<=$cuantos;$a++) {
    list ($ff, $fv) = preg_split("/=/",$campos[$a-1],2);
    if(!isset($valid_fields[$ff])) { $valid_fields[$ff]='varchar(255)'; }
    if(!isset($valid_data[$ff])) { $valid_data[$ff]=$fv; }
}


    // table exist, check table structure, if new fields, add it, leave old fields behind
    foreach($valid_fields as $name=>$type) {
        if(!$db->column_exists($tablename,$name)) {
            if (strpos($type, 'varchar') !== false && strpos($type, 'primary key') === false) {
                $type .= " default ''";
            } elseif (strpos($type, 'timestamp') !== false) {
                $type = str_replace('timestamp', 'timestamp DEFAULT CURRENT_TIMESTAMP', $type);
            }
            $query = "ALTER TABLE `$tablename` ADD `$name` $type";
            $db->consulta($query);
        }
    }

$partupdate=array();
$partvalues=array();
$valueholde=array();

$partvalues[]=$tablename;

foreach($valid_data as $name=>$value) {
    $name = strtolower($name);
    $partupdate[] = "`$name`";
    $valueholde[] = "'%s'";
    $partvalues[] = $value;
}

$query = "REPLACE INTO %s (".implode(",",$partupdate).") VALUES (".implode(",",$valueholde).")";
$db->consulta($query,$partvalues);

